unit DtlCore;

interface

type
  ENUM_DTL_RB_COLOR     = (RED, BLACK);
  RDtlContainerIterator = record
    owner      : TObject;
    current_i  : integer;
    current_e  : pointer;
    isBackward : boolean;
  end;


const
  DtlEmptyIterator : RDtlContainerIterator = (
    owner      : nil;
    current_i  : 0;    current_e  : nil;
    isBackward : false);

function  DTL_COMPARE_INT(a, b : integer) : integer;
function  DTL_COMPARE_CHAR(a, b : char) : integer;
function  DTL_COMPARE_STR(const a, b : string) : integer;
function  DTL_COMPARE_TEXT(const a, b : string) : integer;
function  DTL_COMPARE_ANSISTR(const a, b : string) : integer;
function  DTL_COMPARE_ANSITEXT(const a, b : string) : integer;

procedure Dtl_UT_result_show(const get, need : string);

implementation uses SysUtils, Math;

procedure Dtl_UT_result_show(const get, need : string);
begin
  if get = need
    then begin writeln(' OK   ', get); end
    else begin writeln('*** ERR NEED ', need); writeln('         GET ', get); end;
end;

function  DTL_COMPARE_CHAR(a, b : char) : integer;
begin Result := sign(byte(a) - byte(b)); end;

function  DTL_COMPARE_INT(a, b : integer) : integer;
begin Result := sign(a - b); end;

function  DTL_COMPARE_STR(const a, b : string) : integer;
begin Result := sign(CompareStr(a, b)); end;

function  DTL_COMPARE_TEXT(const a, b : string) : integer;
begin Result := sign(CompareText(a, b)); end;

function  DTL_COMPARE_ANSISTR(const a, b : string) : integer;
begin Result := sign(AnsiCompareStr(a, b)); end;

function  DTL_COMPARE_ANSITEXT(const a, b : string) : integer;
begin Result := sign(AnsiCompareText(a, b)); end;

end.
