{$I 'dtl.linkedlist.inc'}
{$I 'dtl.stack.inc'}
{$I 'dtl.queue.inc'}
{$I 'dtl.deque.inc'}
{$I 'dtl.prqueue.inc'}
{$I 'dtl.array.inc'}
{$I 'dtl.vector.inc'}
{$I 'dtl.set.inc'}
{$I 'dtl.multiset.inc'}
{$I 'dtl.map.inc'}
{$I 'dtl.multimap.inc'}

// DTL -----------------------------------------------------------------------
// Delphi Template Library / Core module
// DTL MISC ----------------------------------------------------------------

# DTL_MAP `x `xs          => _BEGIN_ DTL_MAP_BEGIN `x DTL_MAP_CONT `xs _END_;
# DTL_MAP_CONT `x `xs     => _BEGIN_ DTL_MAP_CONT `x DTL_MAP_CONT `xs _END_;
# DTL_MAP_BEGIN `x ON `fn => _BEGIN_
  `fn `x
    _END_;
# DTL_MAP_CONT `x ON `fn  => _BEGIN_
  ON `fn; `fn `x
    _END_;

// foreach

# DTL_FOREACH_CONST_WHERE `iterator `e IN `container WHEN `cond DO `cmd => _BEGIN_
    if `container.is_iterator_valid(`iterator) then
      repeat
        `e := `container.get_value_at(`iterator);
        if not (`cond) then continue;
        `cmd `e;
        `container.set_value_at(`iterator, `e);
      until not `container.next_iterator(`iterator)
  _END_;

# DTL_FOREACH_CONST_WHERE `iterator `e IN `container WHEN `cond DO `cmd => _BEGIN_
    if `container.is_iterator_valid(`iterator) then
      repeat
        `e := `container.get_value_at(`iterator);
        if `cond then `cmd `e;
      until not `container.next_iterator(`iterator)
  _END_;

# DTL_FOREACH MUTABLE `e IN `container WHEN `cond DO `cmd => _BEGIN_
  begin
    ``iterator : RDtlContainerIterator := `container.head_iterator;
    DTL_FOREACH_MUTABLE_WHERE ``iterator `e IN `container WHEN `cond DO `cmd;
  end;
  _END_;

# DTL_FOREACH MUTABLE `e IN_REVERSED `container WHEN `cond DO `cmd => _BEGIN_
  begin
    ``iterator : RDtlContainerIterator := `container.tail_iterator;
    DTL_FOREACH_MUTABLE_WHERE ``iterator `e IN `container WHEN `cond DO `cmd;
  end;
  _END_;

# DTL_FOREACH `e IN `container WHEN `cond DO `cmd => _BEGIN_
  begin
    ``iterator : RDtlContainerIterator := `container.head_iterator;
    DTL_FOREACH_CONST_WHERE ``iterator `e IN `container WHEN `cond DO `cmd;
  end;
  _END_;

# DTL_FOREACH `e IN_REVERSED `container WHEN `cond DO `cmd => _BEGIN_
  begin
    ``iterator : RDtlContainerIterator := `container.tail_iterator;
    DTL_FOREACH_CONST_WHERE ``iterator `e IN `container WHEN `cond DO `cmd;
  end;
  _END_;



# DTL_FOREACH `e IN `container DO `cmd => _BEGIN_
  begin
    ``iterator : RDtlContainerIterator := `container.head_iterator;
    DTL_FOREACH_CONST_WHERE ``iterator `e IN `container WHEN true DO `cmd;
  end;
  _END_;

# DTL_FOREACH `e IN_REVERSED `container DO `cmd => _BEGIN_
  begin
    ``iterator : RDtlContainerIterator := `container.tail_iterator;
    DTL_FOREACH_CONST_WHERE ``iterator `e IN `container WHEN true DO `cmd;
  end;
  _END_;


// formapeach 

# DTL_FORMAPEACH_CONST_WHERE `iterator `k `v IN `container WHEN `cond DO `cmd => _BEGIN_
    if `container.is_iterator_valid(`iterator) then
      repeat
        `k := `container.get_value_at(`iterator);
        `v := `container.get_data_at(`iterator);
        if not (`cond) then continue;
        `cmd `k `v;
        `container.set_data_at(`iterator, `k, `v);
      until not `container.next_iterator(`iterator)
  _END_;

# DTL_FORMAPEACH_CONST_WHERE `iterator `k `v IN `container WHEN `cond DO `cmd => _BEGIN_
    if `container.is_iterator_valid(`iterator) then
      repeat
        `k := `container.get_value_at(`iterator);
        `v := `container.get_data_at(`iterator);
        if `cond then `cmd `k `v;
      until not `container.next_iterator(`iterator)
  _END_;

# DTL_FORMAPEACH MUTABLE `k `v IN `container WHEN `cond DO `cmd => _BEGIN_
  begin
    ``iterator : RDtlContainerIterator := `container.head_iterator;
    DTL_FORMAPEACH_MUTABLE_WHERE ``iterator `k `v IN `container WHEN `cond DO `cmd;
  end;
  _END_;

# DTL_FORMAPEACH MUTABLE `k `v IN_REVERSED `container WHEN `cond DO `cmd => _BEGIN_
  begin
    ``iterator : RDtlContainerIterator := `container.tail_iterator;
    DTL_FORMAPEACH_MUTABLE_WHERE ``iterator `k `v IN `container WHEN `cond DO `cmd;
  end;
  _END_;

# DTL_FORMAPEACH `k `v IN `container WHEN `cond DO `cmd => _BEGIN_
  begin
    ``iterator : RDtlContainerIterator := `container.head_iterator;
    DTL_FORMAPEACH_CONST_WHERE ``iterator `k `v IN `container WHEN `cond DO `cmd;
  end;
  _END_;

# DTL_FORMAPEACH `k `v IN_REVERSED `container WHEN `cond DO `cmd => _BEGIN_
  begin
    ``iterator : RDtlContainerIterator := `container.tail_iterator;
    DTL_FORMAPEACH_CONST_WHERE ``iterator `k `v IN `container WHEN `cond DO `cmd;
  end;
  _END_;



# DTL_FORMAPEACH `k `v IN `container DO `cmd => _BEGIN_
  begin
    ``iterator : RDtlContainerIterator := `container.head_iterator;
    DTL_FORMAPEACH_CONST_WHERE ``iterator `k `v IN `container WHEN true DO `cmd;
  end;
  _END_;

# DTL_FORMAPEACH `k `v IN_REVERSED `container DO `cmd => _BEGIN_
  begin
    ``iterator : RDtlContainerIterator := `container.tail_iterator;
    DTL_FORMAPEACH_CONST_WHERE ``iterator `k `v IN `container WHEN true DO `cmd;
  end;
  _END_;



