//   DTL -----------------------------------------------------------------------
//   Delphi Template Library
//      Set module define
//        - MAP

# DTL_DECLARE MAP OF `elemtype `datatype AS `container ORDER_BY `comp_fn => _BEGIN_
      DTL_DECLARE_TREENODE_ITEM `container `elemtype
      data : `datatype;
    end;

type
    `container = class (TInterfacedObject, ISmartInterface)
    private
      FDefaultData  : `datatype;
      procedure FreeItemInList;  begin InnerDeleteNode(FTailItem); end;
      function  ConsTreeItem(const value : `elemtype) : P\`container\LinkedItem\`elemtype;
                                begin New(Result); Result.value := value; end;

      DTL_CONTAINER_BOUNDS_DECLARATIONS    `container `elemtype;
      DTL_CONTAINER_TREE_FUNCTIONS         `container `elemtype `comp_fn;
      DTL_DECLARE_LINKEDLIST_ITERATORS     `container `elemtype;
      DTL_DECLARE_ITERATENEXTPREV_TREE     `container `elemtype;
    public
      function  is_exists(const value : `elemtype) : boolean; begin Result := FindNode(value) <> nil; end;
      function  insert(const value : `elemtype; const data : `datatype) : P\`container\LinkedItem\`elemtype; overload;
          begin Result := InnerInsertNode(value); Result.data := data; end;
      procedure remove(const value : `elemtype); overload; begin InnerDeleteNode(FindNode(value)); end;
      function  get_data_at(var iterator : RDtlContainerIterator) : `datatype;
                    begin Result := P\`container\LinkedItem\`elemtype(iterator.current_e).data; end;
      procedure set_data_at(var iterator : RDtlContainerIterator; const value : `datatype);
                    begin P\`container\LinkedItem\`elemtype(iterator.current_e).data := value; end;

      DTL_CONTAINER_INNER_ARRAYED_OVERLOAD_PR `elemtype remove;
    public
      function  GetItems(const keyindex : `elemtype) : `datatype;
          begin `x : P\`container\LinkedItem\`elemtype := FindNode(keyindex);
                if `x <> nil then Result := `x.data else Result := FDefaultData;
          end;
          
      property DefaultData : `datatype read Result := FDefaultData write FDefaultData := value;
      property Items[const keyindex : `elemtype] : `datatype
          read GetItems write begin insert(keyindex, Value); end; default;
    public
  _END_;


