//   DTL -----------------------------------------------------------------------
//   Delphi Template Library
//      Set module define
//        - MULTIMAP 


# DTL_DECLARE MULTIMAP OF `elemtype `datatype IN `valuecontainer AS `container ORDER_BY `comp_fn => _BEGIN_
      DTL_DECLARE_TREENODE_ITEM `container `elemtype
      data : `valuecontainer;
    end;

type
    `container = class (TInterfacedObject, ISmartInterface)
    private
      FDefaultData  : `valuecontainer;
      procedure FreeItemInList; begin InnerDeleteNode(FTailItem); end;

      function  ConsTreeItem(const value : `elemtype) : P\`container\LinkedItem\`elemtype;
                    begin New(Result); Result.value := value; end;
    public
      DTL_CONTAINER_BOUNDS_DECLARATIONS    `container `elemtype;
      DTL_CONTAINER_TREE_FUNCTIONS         `container `elemtype `comp_fn;
      DTL_DECLARE_ITERATENEXTPREV_TREE     `container `elemtype;
      DTL_DECLARE_LINKEDLIST_ITERATORS     `container `elemtype;

    public
      function  is_exists(const value : `elemtype) : boolean; begin Result := FindNode(value) <> nil; end;
      function  insert(const value : `elemtype; const data : `datatype) : P\`container\LinkedItem\`elemtype; overload;
          begin
            Result := InnerInsertNode(value);
            if Result.data = nil then Result.data := `valuecontainer.Create;
            Result.data.insert(data);
          end;
      function  insert(const value : `elemtype; const xs : array of `datatype) : P\`container\LinkedItem\`elemtype; overload;
          begin
            Result := InnerInsertNode(value);
            if Result.data = nil then Result.data := `valuecontainer.Create;
            for `i : integer := low(xs) to high(xs) do Result.data.insert(xs[`i]);
          end;
      procedure remove(const value : `elemtype); overload;
          begin InnerDeleteNode(FindNode(value)); end;

      function  GetItems(const keyindex : `elemtype) : `valuecontainer;
          begin `x : P\`container\LinkedItem\`elemtype := FindNode(keyindex);
                if `x <> nil then Result := `x.data else Result := FDefaultData;
          end;
      function  get_data_at(var iterator : RDtlContainerIterator) : `valuecontainer;
                    begin Result := P\`container\LinkedItem\`elemtype(iterator.current_e).data; end;
      procedure set_data_at(var iterator : RDtlContainerIterator; const value : `valuecontainer);
                    begin P\`container\LinkedItem\`elemtype(iterator.current_e).data := value; end;

      DTL_CONTAINER_INNER_ARRAYED_OVERLOAD_PR `elemtype remove;
    public
      property DefaultData : `valuecontainer read Result := FDefaultData write FDefaultData := value;
      property Items[const keyindex : `elemtype] : `valuecontainer
          read GetItems; default;
    public
  _END_;


