//   DTL -----------------------------------------------------------------------
//   Delphi Template Library
//      Set module define
//        - SET
//        - MULTISET

//         Unique Associative Container, meaning that no two elements are the same.

# DTL_DECLARE MULTISET OF `elemtype AS `container ORDER_BY `comp_fn => _BEGIN_
      DTL_DECLARE_TREENODE_ITEM `container `elemtype
      valuecount : integer;
    end;

type
    `container = class (TInterfacedObject, ISmartInterface)
    private
      procedure FreeItemInList; begin InnerRemoveTail; end;
      procedure InnerRemoveTail;
                    begin
                      if FTailItem <> nil
                        then begin FTailItem.valuecount := FTailItem.valuecount - 1;
                                if FTailItem.valuecount = 0 then InnerDeleteNode(FTailItem) else DecCount;
                        end;
                    end;
      function  ConsTreeItem(const value : `elemtype) : P\`container\LinkedItem\`elemtype;
                                begin New(Result); Result.value := value; Result.valuecount := 1; end;
      DTL_CONTAINER_BOUNDS_DECLARATIONS    `container `elemtype;
      DTL_CONTAINER_TREE_FUNCTIONS         `container `elemtype `comp_fn;
      DTL_DECLARE_LINKEDLIST_ITERATORS     `container `elemtype;
      DTL_DECLARE_ITERATENEXTPREV_MULTISET `container `elemtype;
    public
      function  is_exists(const value : `elemtype) : boolean; begin Result := FindNode(value) <> nil; end;
      function  count_of(const value : `elemtype) : integer;
                    begin
                      Result := 0; `item : P\`container\LinkedItem\`elemtype := FindNode(value);
                     if `item <> nil then Result := `item.valuecount;
                    end;
      function  insert(const value : `elemtype) : P\`container\LinkedItem\`elemtype; overload;
                    begin
                      Result := FindNode(value);
                      if Result = nil
                        then Result := InnerInsertNode(value)
                        else Result.valuecount := Result.valuecount + 1;
                    end;
      procedure remove(const value : `elemtype); overload;
                    begin
                      `item : P\`container\LinkedItem\`elemtype := FindNode(value);
                      if `item <> nil
                        then begin `item.valuecount := `item.valuecount - 1;
                                if `item.valuecount = 0 then InnerDeleteNode(`item);
                        end;
                    end;
      DTL_CONTAINER_INNER_ARRAYED_OVERLOAD_FN `container `elemtype insert;
      DTL_CONTAINER_INNER_ARRAYED_OVERLOAD_PR `elemtype remove;
    public
  _END_;


