//   DTL -----------------------------------------------------------------------
//   Delphi Template Library
//      Set module define
//        - SET
//        - MULTISET

//         Unique Associative Container, meaning that no two elements are the same.

# DTL_DECLARE SET OF `elemtype AS `container ORDER_BY `comp_fn => _BEGIN_
       DTL_DECLARE_TREENODE_ITEM `container `elemtype
    end;

type
    `container = class (TInterfacedObject, ISmartInterface)
    private
      function  ConsTreeItem(const value : `elemtype) : P\`container\LinkedItem\`elemtype;
                                begin New(Result); Result.value := value; end;
      procedure FreeItemInList; begin InnerDeleteNode(FHeadItem); end;
      DTL_CONTAINER_BOUNDS_DECLARATIONS    `container `elemtype;
      DTL_CONTAINER_TREE_FUNCTIONS         `container `elemtype `comp_fn;
      DTL_DECLARE_LINKEDLIST_ITERATORS     `container `elemtype;
      DTL_DECLARE_ITERATENEXTPREV_TREE     `container `elemtype;

    public
      constructor Create(const values : array of `elemtype); overload;
          begin inherited Create; insert(values); end;
      function  is_exists(const value : `elemtype) : boolean; begin Result := FindNode(value) <> nil; end;
      function  insert(const value : `elemtype) : P\`container\LinkedItem\`elemtype; overload; begin Result := InnerInsertNode(value); end;
      procedure remove(const value : `elemtype); overload; begin InnerDeleteNode(FindNode(value)); end;
      DTL_CONTAINER_INNER_ARRAYED_OVERLOAD_FN `container `elemtype insert;
      DTL_CONTAINER_INNER_ARRAYED_OVERLOAD_PR `elemtype remove;

    public
      function  intersect(const values : array of `elemtype) : `container; overload;
          begin Result := intersect(`container.Create(values)); end;
      function  intersect(xs : `container) : `container; overload;
          begin Result := `container.Create; `i : `elemtype := `i;
            DTL_FOREACH `i IN xs DO (# e => _BEGIN_ if is_exists(e) then Result.insert(e) _END_);  end;
      function  union(const values : array of `elemtype) : `container; overload;
          begin Result := union(`container.Create(values)); end;
      function  union(xs : `container) : `container; overload;
          begin Result := `container.Create; `i : `elemtype := `i;
            DTL_FOREACH `i IN self DO (# e => _BEGIN_ Result.insert(e) _END_);
            DTL_FOREACH `i IN xs DO (# e => _BEGIN_ Result.insert(e) _END_);
          end;


    public
 _END_;


