//   DTL -----------------------------------------------------------------------
//   Delphi Template Library
//      Containers module define
//        - VECTOR

# DTL_DECLARE VECTOR OF `elemtype `size AS `container =>
    DTL_DECLARE VECTOR OF `elemtype `size `size AS `container;

# DTL_DECLARE VECTOR OF `elemtype `size `grow_by AS `container => _BEGIN_
    `container = class (TInterfacedObject, ISmartInterface)
    private
      FItems : array of `elemtype;
      FCount, FCapacity, FGrowIncrement : integer;
      DTL_DECLARE_INDEXED_ITERATORS `container `elemtype;
    public
      constructor Create;
        begin
          SetLength(FItems, `size); FCount := `size; FCapacity := `size;
          FGrowIncrement := `grow_by; if FGrowIncrement <= 0 then FGrowIncrement := 10;
        end;
      destructor Destroy; override; begin while not is_empty do pop_back; inherited; end;

      function  GetItem(const index : integer) : `elemtype; begin Result := FItems[index]; end;
      procedure SetItem(const index : integer; const Value : `elemtype); begin FItems[index] := Value; end;

      function  is_empty : boolean; begin Result := FCount = 0; end;
      function  count : integer; begin Result := FCount; end;

      procedure insert(const value : `elemtype); begin push_back(value); end;

      procedure push_back(const value : `elemtype); overload;
        begin
          if FCount >= FCapacity then
              begin FCapacity := FCapacity + FGrowIncrement; SetLength(FItems, FCapacity); end;
          FItems[FCount] := value; FCount:= FCount + 1;
        end;
      function  pop_back : `elemtype; begin FCount:= FCount - 1; Result := FItems[FCount]; end;
      DTL_CONTAINER_INNER_ARRAYED_OVERLOAD_PR `elemtype  push_back;

      property  Items[const index : integer] : `elemtype read GetItem write SetItem; default;
    public
  _END_;

