unit dtlutdeque;

interface uses DtlCore, Contnrs, SysUtils, Math, Classes;

{$I 'dtl.core.inc'}

procedure dtldequeUT;

implementation

type
  DTL_DECLARE DEQUE OF CHAR AS TCharDeque END;
  DTL_DECLARE DEQUE OF INTEGER AS TIntDeque END;

procedure dtldequeUT;
var
  cdeque : TCharDeque;
  ideque : TIntDeque;
  ch : char;
  s : string;
  i : integer;
begin
  cdeque := TCharDeque.Create;
  cdeque.push_head(['A', 'B', 'C']);
  cdeque.push_tail(['1', '2', '3']);

  s := Format('CHAR ITER DEQUE [%d] : ', [cdeque.count]);
  DTL_FOREACH ch IN cdeque DO (# `e => _BEGIN_ s := s + Format('%s', [`e]) _END_);
  Dtl_UT_result_show(s, 'CHAR ITER DEQUE [6] : CBA123');
  s := Format('CHAR REVER DEQUE [%d] : ', [cdeque.count]);
  DTL_FOREACH ch IN_REVERSED cdeque DO (# `e => _BEGIN_ s := s + Format('%s', [`e]) _END_);
  Dtl_UT_result_show(s, 'CHAR REVER DEQUE [6] : 321ABC');

  s := Format('CHAR DEQUE [%d] : ', [cdeque.count]);
  while cdeque.count > 3 do s := s + cdeque.pop_head;
  while not cdeque.is_empty do s := s + cdeque.pop_tail;
  Dtl_UT_result_show(s, 'CHAR DEQUE [6] : CBA321');
//
  ideque := TIntDeque.Create;
  for i := 9 downto 1 do ideque.insert(i);

  s := Format('CHAR ITER DEQUE [%d] : ', [ideque.count]);
  DTL_FOREACH i IN ideque WHEN (i mod 2 = 1) DO (# `e => _BEGIN_ s := s + Format('%d', [`e]) _END_);
  Dtl_UT_result_show(s, 'CHAR ITER DEQUE [9] : 97531');
  s := Format('CHAR REVER DEQUE [%d] : ', [ideque.count]);
  DTL_FOREACH i IN_REVERSED ideque WHEN (i mod 3 <> 1) DO (# `e => _BEGIN_ s := s + Format('%d', [`e]) _END_);
  Dtl_UT_result_show(s, 'CHAR REVER DEQUE [9] : 235689');

  s := Format('INT DEQUE  [%d] : ', [ideque.count]);
  while not ideque.is_empty do s := s + Format('%d.', [ideque.pop_tail]);
  Dtl_UT_result_show(s, 'INT DEQUE  [9] : 1.2.3.4.5.6.7.8.9.');
  for i := 1 to 9 do ideque.insert(i);
  s := Format('INT DEQUE  [%d] : ', [ideque.count]);
  while not ideque.is_empty do s := s + Format('%d.', [ideque.pop_head]);
  Dtl_UT_result_show(s, 'INT DEQUE  [9] : 1.2.3.4.5.6.7.8.9.');
//
end;

end.
