unit dtlutmultimap;

interface uses DtlCore, Contnrs, SysUtils, Math, Classes;

{$I 'dtl.core.inc'}

procedure dtlMultiMapUT;

implementation

type
  DTL_DECLARE STACK OF Integer AS TIntegerStack end;
  DTL_DECLARE MULTIMAP OF string integer IN TIntegerStack AS TMonthMap order_by DTL_COMPARE_STR END;

procedure dtlMultiMapUT;
var
  cmap : TMonthMap;
  s, si : string;
  i : integer;
  ist : TIntegerStack;
begin
  cmap := TMonthMap.Create;
  cmap.insert('symbol', [11, 12, 13, 14, 15, 16, 17]);
  cmap.insert('digit', 1);
  cmap.insert('digit', 1);
  cmap.insert('info' , [110, 104]);
  cmap.insert('digit', 2);
  cmap.insert('digit', 3);

  s := Format('CHAR ITER MULTIMAP [%d] : ', [cmap.count]);
  DTL_FORMAPEACH si ist IN cmap DO (# `k `v => _BEGIN_ s := s + Format(' %s[%d]', [`k, `v.count]) _END_);
  Dtl_UT_result_show(s, 'CHAR ITER MULTIMAP [3] :  digit[4] info[2] symbol[7]');

  s := Format('CHAR ITER MULTIMAP [%d] : ', [cmap.count]);
  DTL_FORMAPEACH si ist IN cmap DO (# `k `v =>
    _BEGIN_
       s := s + Format(' %s[', [`k]);
       DTL_FOREACH i IN `v DO (# `e => _BEGIN_ s := s + Format('.%d', [i]) _END_ );
       s := s + ']';
    _END_
    );
  Dtl_UT_result_show(s, 'CHAR ITER MULTIMAP [3] :  digit[.3.2.1.1] info[.104.110] symbol[.17.16.15.14.13.12.11]');

  cmap.remove('digit');
  s := Format('CHAR ITER MULTIMAP [%d] : ', [cmap.count]);
  DTL_FORMAPEACH si ist IN cmap DO (# `k `v =>
    _BEGIN_
       s := s + Format(' %s[', [`k]);
       DTL_FOREACH i IN `v DO (# `e => _BEGIN_ s := s + Format('.%d', [i]) _END_ );
       s := s + ']';
    _END_
    );
  Dtl_UT_result_show(s, 'CHAR ITER MULTIMAP [2] :  info[.104.110] symbol[.17.16.15.14.13.12.11]');

//
  if not cmap.is_exists('info')
      then writeln('*** ERR VALUE NOT FOUND IN map ', 'info')
      else writeln(' OK   VALUE info FOUND IN map');
  if cmap.is_exists('junea') then writeln('*** ERR BAD VALUE FOUND IN map ', 'junea')
      else writeln(' OK   VALUE junea NOT FOUND IN map');

//
end;


end.
