unit dtlutprqueue;

interface uses DtlCore, Contnrs, SysUtils, Math, Classes;

{$I 'dtl.core.inc'}

procedure dtlprqueueUT;

implementation

type
  DTL_DECLARE PRIORITYQUEUE OF CHAR    AS TCharPrQueue order_by DTL_COMPARE_CHAR END;
  DTL_DECLARE PRIORITYQUEUE OF INTEGER AS TIntPrQueue  order_by DTL_COMPARE_INT  END;

procedure dtlprqueueUT;
var
  cqueue : TCharPrQueue;
  iqueue : TIntPrQueue;
  s : string;
  i : integer;
  ch : char;
begin
  cqueue := TCharPrQueue.Create;
  cqueue.push(['1', '2', '3']);
  cqueue.push('A');
  cqueue.push(['1', '3']);
  cqueue.push(['E', 'C']);

  s := Format('CHAR ITER PRQUEUE [%d] : ', [cqueue.count]);
  DTL_FOREACH ch IN cqueue DO (# `e => _BEGIN_ s := s + Format('%s', [`e]) _END_);
  Dtl_UT_result_show(s, 'CHAR ITER PRQUEUE [8] : 11233ACE');
  s := Format('CHAR REVER PRQUEUE [%d] : ', [cqueue.count]);
  DTL_FOREACH ch IN_REVERSED cqueue DO (# `e => _BEGIN_ s := s + Format('%s', [`e]) _END_);
  Dtl_UT_result_show(s, 'CHAR REVER PRQUEUE [8] : ECA33211');
  
  s := Format('CHAR PRQUEUE [%d] : ', [cqueue.count]);
  while not cqueue.is_empty do s := s + cqueue.pop;
  Dtl_UT_result_show(s, 'CHAR PRQUEUE [8] : ECA33211');
//
  iqueue := TIntPrQueue.Create;
  for i := 1 to 9 do iqueue.insert(i);
  s := Format('INT PRQUEUE  [%d] : ', [iqueue.count]);
  while not iqueue.is_empty do s := s + Format('%d.', [iqueue.pop]);
  Dtl_UT_result_show(s, 'INT PRQUEUE  [9] : 9.8.7.6.5.4.3.2.1.');
//
  iqueue := TIntPrQueue.Create;
  for i := 1 to 9 do iqueue.insert(i);
  if not iqueue.is_exists(4)
      then writeln('*** ERR VALUE NOT FOUND IN PRQUEUE ', 4)
      else writeln(' OK   VALUE 4 FOUND IN PRQUEUE');
  if iqueue.is_exists(10) then writeln('*** ERR BAD VALUE FOUND IN PRQUEUE ', 10)
      else writeln(' OK   VALUE 10 NOT FOUND IN PRQUEUE');
  s := Format('INT PRQUEUE  [%d] : ', [iqueue.count]);
  while not iqueue.is_empty do s := s + Format('%d.', [iqueue.pop]);
  Dtl_UT_result_show(s, 'INT PRQUEUE  [9] : 9.8.7.6.5.4.3.2.1.');
//
end;

end.
