unit dtlutset;

interface uses DtlCore, Contnrs, SysUtils, Math, Classes;

{$I 'dtl.core.inc'}

procedure dtlsetUT;

implementation

type
  DTL_DECLARE SET OF CHAR    AS TCharSet order_by DTL_COMPARE_CHAR END;
  DTL_DECLARE SET OF INTEGER AS TIntSet  order_by DTL_COMPARE_INT  END;

procedure dtlsetUT;
var
  cset : TCharSet;
  iset, iset2 : TIntSet;
  i : integer;
  s : string;
  ch : char;
begin
  cset := TCharSet.Create;
  cset.insert(['1', '2', '3']);
  cset.insert('A');
  cset.insert(['1', '3']);
  cset.insert(['E', 'C']);
  s := Format('CHAR SET [%d] : ', [cset.count]);

  s := Format('CHAR ITER SET [%d] : ', [cset.count]);
  DTL_FOREACH ch IN cset DO (# `e => _BEGIN_ s := s + Format('%s', [`e]) _END_);
  Dtl_UT_result_show(s, 'CHAR ITER SET [6] : 123ACE');
  s := Format('CHAR REVER SET [%d] : ', [cset.count]);
  DTL_FOREACH ch IN_REVERSED cset DO (# `e => _BEGIN_ s := s + Format('%s', [`e]) _END_);
  Dtl_UT_result_show(s, 'CHAR REVER SET [6] : ECA321');


//  while not cset.is_empty do s := s + cset.pop;
//  Dtl_UT_result_show(s, 'CHAR SET [6] : ECA33211');
//
  if not cset.is_exists('3')
      then writeln('*** ERR VALUE NOT FOUND IN SET ', 3)
      else writeln(' OK   VALUE 3 FOUND IN SET');
  if cset.is_exists('D') then writeln('*** ERR BAD VALUE FOUND IN SET ', 'D')
      else writeln(' OK   VALUE D NOT FOUND IN SET');

  iset := TIntSet.Create([1, 2, 3, 4, 5]);

  iset2 := iset.intersect([1, 3, 5, 7, 8]);
  s := Format('INT INTERSECT SET [%d] : ', [iset2.count]);
  DTL_FOREACH i IN iset2 DO (# `e => _BEGIN_ s := s + Format('%d', [`e]) _END_);
  Dtl_UT_result_show(s, 'INT INTERSECT SET [3] : 135');

  iset2 := iset.union([1, 3, 5, 7, 8]);
  s := Format('INT UNION SET [%d] : ', [iset2.count]);
  DTL_FOREACH i IN iset2 DO (# `e => _BEGIN_ s := s + Format('%d', [`e]) _END_);
  Dtl_UT_result_show(s, 'INT UNION SET [7] : 1234578');

end;

end.
